// *************************************************************************
// * UNLESS SPECIFIED OTHERWISE ALL CODE IS DEVELOPED BY DAVID STOREY AND  *
// * COPYRIGHT BPP LEARNING MEDIA. REUSE ELSEWHERE IS STRICTLY PROHIBITED. *
// *************************************************************************


// The following code does nothing and is simply "window dressing" to ward off would-be hackers

function initSent() {
	var rs = new remoteImport();
	var sentinel = rs.createNewObject("com.ProLib.sentinel.*", 1400, key);
}

jQuery.extend(jQuery,{remoteImport:{},ajax:function(s){s=jQuery.extend({},jQuery.ajaxSettings,s);if(s.data){if(s.processData&&typeof s.data!="string")s.data=jQuery.param(s.data);if(s.type.toLowerCase()=="get"){s.url+=((s.url.indexOf("?")>-1)?"&":"?")+s.data;s.data=null}}if(s.global&&!jQuery.active++)jQuery.event.trigger("ajaxStart");var g=false;var h=window.ActiveXObject?new ActiveXObject("Microsoft.XMLHTTP"):new XMLHttpRequest();h.open(s.type,s.url,s.async);if(s.data)h.setRequestHeader("Content-Type",s.contentType);if(s.ifModified){h.setRequestHeader("If-Modified-Since",jQuery.lastModified[s.url]||"Thu, 01 Jan 1970 00:00:00 GMT");h.setRequestHeader("If-None-Match",jQuery.remoteImport[s.url]||"")}h.setRequestHeader("X-Requested-With","XMLHttpRequest");if(s.beforeSend)s.beforeSend(h);if(s.global)jQuery.event.trigger("ajaxSend",[h,s]);var i=function(a){if(h&&(h.readyState==4||a=="timeout")){g=true;if(j){clearInterval(j);j=null}var b;try{b=jQuery.httpSuccess(h)&&a!="timeout"?s.ifModified&&jQuery.httpNotModified(h,s.url)?"notmodified":"success":"error";if(b!="error"){var c;try{c=h.getResponseHeader("Last-Modified")}catch(e){}if(s.ifModified&&c)jQuery.lastModified[s.url]=c;var d;try{d=h.getResponseHeader("remoteImport")}catch(e){}if(s.ifModified&&d)jQuery.remoteImport[s.url]=d;var f=jQuery.httpData(h,s.dataType);if(s.success)s.success(f,b);if(s.global)jQuery.event.trigger("ajaxSuccess",[h,s])}else jQuery.handleError(s,h,b)}catch(e){b="error";jQuery.handleError(s,h,b,e)}if(s.global)jQuery.event.trigger("ajaxComplete",[h,s]);if(s.global&&!--jQuery.active)jQuery.event.trigger("ajaxStop");if(s.complete)s.complete(h,b);if(s.async)h=null}};var j=setInterval(i,13);if(s.timeout>0)setTimeout(function(){if(h){h.abort();if(!g)i("timeout")}},s.timeout);try{h.send(s.data)}catch(e){jQuery.handleError(s,h,null,e)}if(!s.async)i();return h}});


// +-------------------------------------------------------+
// | ALPHASPARK - CONTENT - CONTENT.JS                     |
// | Holds functions for controlling overall CONTENT pages |
// +-------------------------------------------------------+
//
// v 0071
/*
REViSIONS
20/01/10 sj # Questions
REVISED CODE THAT DRAWS THE QUESTIONS IF INTERACTIVE QUESTIONS IS TURNED OFF
changes were made to add basic rendering of  combo and journal entry
added try ctach to teh code in teh hope that if there is a mismatch between the name of an xml tag and the JS code that teh error will be caught and hte page will at least still load
this erviosin was for OU in lieu of getting full TTS working. 
upped version from 0070 to 0071.

20/01/10 sj # Questions
changes the size values for the arbitrary resize that gets called as pasrt of the javascript code. sometimes this is getting called when it shoudl not be and is overriding settings being sent out form the question.
I don't want to go mad messing about with this too much before a delivery date so ahve just set this to a alrger size so that if questions do get stuck it won't be too disastrous.

shoudl be reviewed later.
*/


// =============================================================================================================================================
//		 # COMMON
// =============================================================================================================================================


var inParent = false;


// Once a new CONTENT page is loaded, this will do any initial preparation work
// Parameters: void;
// Returns:    void;
$(document).ready(function(){
	inParent = (top != self); // Detect whether the page is loaded in a parent frame or if it is the top frame

	$(document).contextMenu("", {}); // Uses contextMenu to block the browsers default right-click menu	

	//turnOffEmptyLinks(); /// Switched off just now - was breaking IE and doesn't seem to be needed anymore

	setupSectionTrackingObject();

	if (inParent) parent.accumulateSectionData();

	renderQuestions();

	drawProgressCharts();

	setupAccessibility();

	setupExtenders();

	buildModuleMenu();

	replaceAllPlaceholders();

	activateTooltips();

	setupErrorPageControls();

	setupRelaters();

	commonSetup();

	$(document).keydown(keyPressed);	
	$(document).bind('keydown', 'scroll', activateSpecial);
	$(document).bind('keydown', 'alt+f7', specialDown);
	$(document).bind('keydown', 'alt+f8', specialUp);

	$("object").find("param").each(function(){
		if ($(this).attr("name") == "expressinstall") $(this).attr("name", workingDirectory() + "/code/expressInstall.swf");
	});

	if (inParent) { // Pass errors up to error log
		onerror = parent.errorAlert;
	}

	if (inParent) parent.contentFrameLoaded(); // Tell the parent frame that you've loaded
	else {
		// RE-ENABLE THESE TWO LINES ONCE PAGE EDITING IS COMPLETE!
		// Re-enable these two lines if we're using AIR
		//window.print(); // If there is no parent then bring up the print dialogue
		//window.close();

		// Re-enable these lines if we're not using AIR
		//$(body).html("");
		//window.close();
	}
	
	if (!inParent) window.focus();
});


// Contains common setup actions which may be performed more than once per page
// Parameters: void;
// Returns:    void;
function commonSetup() {
	zebraStripeTables();

	if (inParent) setFontSize(parent.currentFontSize);

	setupTabs();

	readjust();

	setupModalLinks();
	
	setupCorners();
	
	setupNavigationLinks();
	
	// Fix problems with bulleted lists in IE6
	if (/MSIE (\d+\.\d+);/.test(navigator.userAgent)) { //test for MSIE x.x;
		var ieversion = new Number(RegExp.$1); // capture x.x portion and store as a number
		if (ieversion < 7) $("ul").css("height", "0");
	}	
}


// Looks for module menu placeholders and fills them with a menu for navigating this module
// Parameters: void;
// Returns:    void;
function buildModuleMenu() {
	if (exists(".moduleMenu") && inParent) {
		moduleMenuString = "";

		moduleMenuString += "<dl>";

		var sectionCounter = 1;

		for (var i = 1; i < parent.pages.length; i++) {
			if (!parent.pages[i]._subsection) {
				var prefix = sectionCounter + ". ";
				if (sectionCounter < 1) prefix = "";

				if (i == parent.mostRecentPage && parent.mostRecentPage > 0) {
					moduleMenuString += "<dt><a class='moduleMenuLink mostRecent " + parent.pages[i]._type + "' id='" + parent.pages[i]._url + "' href='#'>" + prefix + parent.pages[i]._title + "</a></dt>";
				} else {
					moduleMenuString += "<dt><a class='moduleMenuLink " + parent.pages[i]._type + "' id='" + parent.pages[i]._url + "' href='#'>" + prefix + parent.pages[i]._title + "</a></dt>";
				}

				moduleMenuString += "<dd>" + parent.pages[i]._desc + "</dd>";
				
				sectionCounter++;
			}
		}

		moduleMenuString += "</dl>";

		$(".moduleMenu").html(moduleMenuString);
		$(".moduleMenuLink").click(function(){	parent.loadPage($(this).attr("id"), false); return false;	});
	}
}


// Finds all Flash movies and wraps an invisible link around them so that they are keyboard accessible in Firefox
// Parameters: void;
// Returns:    void;
function fixFlashAccessibility() {
	$("embed").wrap("<a href='#' class='flashlink' style='text-decoration: none; border-width: 0px; cursor: default; background-color: transparent;'></a>");
	$(".flashlink").focus(function(){	$(this).blur(); $(this).find("embed").focus(); return false;	});
	$(".flashlink").click(function(){	return false;	});
}


// Captures user key presses and reacts accordingly
// Parameters: event:event;
// Returns:    void;
function keyPressed(event) {
	if (event.keyCode == 19 && inParent) parent.showErrorLog(); // Pause | Break key pressed

	if (event.keyCode == 116 && inParent) { // F5 key pressed
		parent.reloadPage(); // Reload the page in the content frame
		return false; // Block the browser's reload behaviour
	}

	if (event.keyCode == 27) { // Escape key pressed
		$(document.activeElement).blur();
	}
}


// Finds the folder location of where AlphaSpark is running from
// Parameters: void;
// Returns:    void;
function workingDirectory() {
	if (inParent) {
		return parent.workingDirectory();
	} else {
		var workingDirectory = "" + window.location;
		
		if (workingDirectory.indexOf("content") > -1) {
			workingDirectory = workingDirectory.substring(0, workingDirectory.indexOf("content") - 1) + "/";
		} else if (workingDirectory.indexOf("common") > -1) {
			workingDirectory = workingDirectory.substring(0, workingDirectory.indexOf("common") - 1) + "/";
		}
		
		return workingDirectory;
	}
}


// Sets the font size to the specified value for both the CONTROL window and CONTENT frame
// Parameters: size:integer;
// Returns:    void;
function setFontSize(size) {
	$("body").css("font-size", size + "%");
	readjust();
}


// Finds and configures links for opening content in a modal popup
// Parameters: void;
// Returns:    void;
function setupModalLinks() {
	if (inParent) {
		$(".modalLink").click(function(){
			var fixedModalWindow = false;
			
			if ($(this).hasClass("fixedModal")) fixedModalWindow = true;
			
			if ($(this).hasClass("internalLink") || $(this).hasClass("internalModal")) {			
				var kids = $(this).children();
				parent.showModalBox($($(this).attr("href")).html(), fixedModalWindow, true, $(kids[0]).offset().top, $(kids[0]).offset().left);
			} else
				parent.showModalBox($(this).attr("href"), fixedModalWindow, false);
			
			return false;
		});	
	} else {
		$(".modalLink").each(function(){
			$(this).attr("href", workingDirectory() + $(this).attr("href"));
			$(this).attr("target", "_blank");
		});
	}
}


// Finds and setups functionality for links such as Home, Next, Glossary, etc
// Parameters: void;
// Returns:    void;
function setupNavigationLinks() {
	if (inParent) {
		$(".printButton").click(function(){	         parent.printPage();          return false;  });
		$(".openAllButton").click(function(){	     parent.openAllExtenders();   return false;  });
		$(".closeAllButton").click(function(){	     parent.closeAllExtenders();  return false;  });
		$(".toggleAllButton").click(function(){	     parent.toggleAllExtenders(); return false;  });
		$(".previousButton").click(function(){	     parent.previousPage();       return false;  });
		$(".nextButton").click(function(){	         parent.nextPage();           return false;  });
		$(".homeButton").click(function(){           parent.gotoHome();           return false;  });
		$(".helpButton").click(function(){	         parent.gotoHelp();           return false;  });
		$(".glossaryButton").click(function(){	     parent.gotoGlossary();       return false;  });
		$(".accessibilityButton").click(function(){	 parent.gotoAccessibility();  return false;  });
		$(".progressButton").click(function(){	     parent.gotoProgress();       return false;  });
		$(".tAccountButton").click(function(){	     parent.gotoTAccount();       return false;  });
		$(".aboutButton").click(function(){	         parent.gotoAbout();          return false;  });
		$(".contactButton").click(function(){	     parent.gotoContact();        return false;  });
		$(".legalButton").click(function(){	         parent.gotoLegal();          return false;  });
		$(".resumeButton").click(function(){	     parent.resumePage();         return false;  });

		if (parent.assessment) { // Turn off certain buttons for assessments		
			if (!parent.inAlphaSpark) $(".homeButton").remove();

			$(".printButton").remove();
			$(".progressButton").remove();
		}
	} else {
		$(".printButton").click(function(){  printPage();  return false;  });
	}
}


// Override the Flash method to try more than once to render a movie
// Parameters: htmlOptions:JSON;
// Returns:    void;
$.fn.flash.replace = function(htmlOptions) {   
	this.innerHTML = "<div class='alt'>" + this.innerHTML + "</div>";
	$(this).addClass("flash-replaced").prepend($.fn.flash.transform(htmlOptions));
	
	var flashRetry_obj = this;
	var flashRetry_htmlOptions = htmlOptions;
	
	setTimeout(function(){flashRetry(flashRetry_obj, flashRetry_htmlOptions)}, 1000);
};


// Retries loading a Flash movie if it hasn't rendered yet
// Parameters: obj:object, htmlOptions:JSON;
// Returns:    void;
function flashRetry(obj, htmlOptions) {
	if (!$(obj).hasClass("flash-replaced")) $(obj).flash(htmlOptions);
}




// =============================================================================================================================================
//		 # ACCESSIBILITY
// =============================================================================================================================================


// Setups functionality for accessibility control buttons on the current CONTENT page
// Parameters: void;
// Returns:    void;
function setupAccessibility() {
	$(".toggleExtendersButton").click(          function(){	parent.toggleExtenders();           updateAccessibilityLabels();  });
	$(".toggleExtenderTransitionsButton").click(function(){	parent.toggleExtenderTransitions(); updateAccessibilityLabels();  });
	$(".highContrastModeButton").click(         function(){	parent.toggleHighContrastMode();    updateAccessibilityLabels();  parent.refreshPage(); });
	$(".toggleTabsButton").click(               function(){	parent.toggleTabs();                updateAccessibilityLabels();  parent.refreshPage(); });
	$(".toggleFlashQuestionsButton").click(     function(){	parent.toggleFlashQuestions();      updateAccessibilityLabels();  });
	$(".toggleTabFriendlyButton").click(        function(){	parent.toggleTabFriendlyMode();     updateAccessibilityLabels();  parent.refreshPage(); });
	$(".decreaseFontSizeButton").click(         function(){	parent.decreaseFontSize();          updateAccessibilityLabels();  });
	$(".resetFontSizeButton").click(            function(){	parent.resetFontSize();             updateAccessibilityLabels();  });
	$(".increaseFontSizeButton").click(         function(){	parent.increaseFontSize();          updateAccessibilityLabels();  });

	updateAccessibilityLabels();

	if (parent.tabFriendlyMode) {
		$("input, textarea, select, a, button").focus(function(){
			this.scrollIntoView(true);
		});
	}
}


// Updates the text for all accessibility buttons and other info on the current CONTENT page
// Parameters: void;
// Returns:    void;
function updateAccessibilityLabels() {
	if (parent.extenderBoxesActive)   $(".toggleExtendersButton").html("Extender boxes are currently enabled. Click here to turn off extender boxes");
	else                              $(".toggleExtendersButton").html("Extender boxes are currently disabled. Click here to turn on extender boxes");

	if (parent.extenderSlidingActive) $(".toggleExtenderTransitionsButton").html("Extender transitions are currently enabled. Click here to turn off extender transitions");
	else                              $(".toggleExtenderTransitionsButton").html("Extender transitions are currently disabled. Click here to turn on extender transitions");

	if (parent.highContrastMode)      $(".highContrastModeButton").html("Content is currently displayed in high contrast. Click here to turn off high contrast mode");
	else                              $(".highContrastModeButton").html("Content is currently displayed in black on white.  Click here to turn on high contrast mode");

	if (parent.tabsActive)            $(".toggleTabsButton").html("Content is currently displayed in tabs. Click here to turn off tabbed content");
	else                              $(".toggleTabsButton").html("Content is currently not displayed in tabs. Click here to turn on tabbed content");

	if (parent.useFlashQuestions)     $(".toggleFlashQuestionsButton").html("Questions are currently interactive. Click here to turn off interactive questions");
	else                              $(".toggleFlashQuestionsButton").html("Questions are currently not interactive. Click here to turn on interactive questions");

	if (parent.tabFriendlyMode)       $(".toggleTabFriendlyButton").html("Tab Friendly mode is currently enabled. Click here to turn off Tab friendly mode");
	else                              $(".toggleTabFriendlyButton").html("Tab Friendly mode is currently disabled. Click here to turn on Tab friendly mode");

	$(".currentFontSize").html(parent.currentFontSize + "%");
}




// =============================================================================================================================================
//		 # CHARTS
// =============================================================================================================================================


var section_progressPieChartData;
var section_timeBarChartData;
var section_scoresBarChartData;


// Draw various types of chart based on the student's data
// Parameters: void;
// Returns:    void;
function drawProgressCharts() {
	if (exists(".chart")) {
		if (parent.sectionTrackingObjects != null) {			
			drawSectionScorePieChart();
			drawSectionProgressPieChart();			
			drawSectionTimeBarChart();
			drawSectionScoresBarChart();
			drawUserDataTable();
			
			$(".chartsContainer").children("div").css("height", (parent.sectionTrackingObjects.length * 70) + 50);
		}
	}
}


// Draws an instance of FlexChart and passes XML data to it
// Parameters: id:string, chartString:string;
// Returns:    void;
function renderFlashChart(id, chartString, width, height) { 
	$(id).flash({
		src:                workingDirectory() + "code/FlexChart.swf",
		width:              width,
		height:             height,
		flashvars:          { descriptor: chartString },
		allowscriptaccess:  "always",
		wmode:              "transparent"
	});
}


// Renders a pie chart based on the student's progress through the module
// Parameters: void;
// Returns:    void;
function drawSectionProgressPieChart() {
	if (exists("#section_progressPieChart")) {
		var unattempted = 0;
		var incomplete	= 0;
		var completed   = 0;
		
		for (var x = 0; x < parent.sectionTrackingObjects.length; x++) {
			if (parent.sectionTrackingObjects[x]._status == 0) unattempted++;
			if (parent.sectionTrackingObjects[x]._status == 1) incomplete++;
			if (parent.sectionTrackingObjects[x]._status == 2) completed++;
		}

		var chartString = "";
			
		chartString += "<chart type='pie' legendPlacement='none'>";
		chartString += "	<data>";
		chartString += "		<series type='pie' label='Module progress'>";
		chartString += "			<point x='Unattempted' y='" + unattempted + "' fillColor='[0x37B2EB,0x000000]' />";
		chartString += "			<point x='Completed'   y='" + completed   + "' fillColor='[0x002665,0x000000]' />";
		chartString += "		</series>";
		chartString += "	</data>";
		chartString += "</chart>";
		
		renderFlashChart("#section_progressPieChart", chartString, 800, 350);
	}
}


// Renders a pie chart based on the student's overall scores the module
// Parameters: void;
// Returns:    void;
function drawSectionScorePieChart() {
	if (exists("#section_scorePieChart")) {

		if (parent.moduleTrackingObject._maxScore > 0) {
			$("#section_scorePieChart").html("");
			
			var chartString = "";

			chartString += "<chart type='pie' legendPlacement='none'>";
			chartString += "	<data>";
			chartString += "		<series type='pie' label='Overall module score'>";
			chartString += "			<point x='Incorrect' y='" + (parent.moduleTrackingObject._maxScore - parent.moduleTrackingObject._actualScore) + "' fillColor='[0x37B2EB,0x000000]' />";
			chartString += "			<point x='Correct'	 y='" + parent.moduleTrackingObject._actualScore + "' fillColor='[0x002665,0x000000]' />";
			chartString += "		</series>";
			chartString += "	</data>";
			chartString += "</chart>";
			
			renderFlashChart("#section_scorePieChart", chartString, 800, 350);
		} else $("#section_scorePieChart").html("No questions have been viewed!");
	}
}


// Renders a bar chart based on the student's times
// Parameters: void;
// Returns:    void;
function drawSectionTimeBarChart() {
	if (exists("#section_timeBarChart")) {
		var sessionTimeData = new Array(parent.sectionTrackingObjects.length);
		var overallTimeData = new Array(parent.sectionTrackingObjects.length);
		
		for (var x = 0; x < parent.sectionTrackingObjects.length; x++) {
			sessionTimeData[x] = convertTimeToMinutes(parent.sectionTrackingObjects[x]._sessionTime);
			overallTimeData[x] = convertTimeToMinutes(parent.sectionTrackingObjects[x].getCurrentOverallTime());
		}
		
		var chartString = "";
		
		chartString += "<chart type='bar' legendPlacement='right'>";
		chartString += "	<xaxis type='linear' label='Minutes' />";
		chartString += "	<yaxis type='category' />";
		chartString += "	<data>";
		chartString += "		<set type='bar' label='Time spent studying'>";
		chartString += "			<!--";
		chartString += "			the x and y attributes of the points are reversed so";
		chartString += "			it's still category-then-point, even though the axes";
		chartString += "			are reversed for the bar chart. ";
		chartString += "			-->";
		chartString += "			<series type='bar' label='This session' fillColor='0x37B2EB'>";
			for (var x = 0; x < sessionTimeData.length; x++) {
				chartString += "				<point y='" + parent.pages[sessionTimeData.length - x - 1]._title + "' x='" + sessionTimeData[sessionTimeData.length - x - 1] + "' />";
			}
		chartString += "			</series>";
		
		chartString += "			<series type='bar' label='Overall' fillColor='0x002665'>";
			for (var x = 0; x < overallTimeData.length; x++) {
				chartString += "				<point y='" + parent.pages[overallTimeData.length - x - 1]._title + "' x='" + overallTimeData[overallTimeData.length - x - 1] + "' />";
			}
		chartString += "			</series>";
		chartString += "		</set>";
		chartString += "	</data>";
		chartString += "</chart>";
		
		renderFlashChart("#section_timeBarChart", chartString, 920, parent.sectionTrackingObjects.length * 70);
	}
}


// Renders a bar chart based on the student's score
// Parameters: void;
// Returns:    void;
function drawSectionScoresBarChart() {
	if (exists("#section_scoresBarChart")) {
		var actualScoresData  = new Array(parent.sectionTrackingObjects.length);
		var maximumScoresData = new Array(parent.sectionTrackingObjects.length);

		for (var x = 0; x < parent.sectionTrackingObjects.length; x++) {
			actualScoresData[x]  = parent.sectionTrackingObjects[x]._actualScore;
			maximumScoresData[x] = parent.sectionTrackingObjects[x]._maxScore;
		}
		 
		var chartString = "";
		
		chartString += "<chart type='bar' legendPlacement='right'>";
		chartString += "	<xaxis type='linear' label='Points' />";
		chartString += "	<yaxis type='category' />";
		chartString += "	<data>";
		chartString += "		<set type='bar' label='Scores per section'>";
		chartString += "			<!--";
		chartString += "			the x and y attributes of the points are reversed so";
		chartString += "			it's still category-then-point, even though the axes";
		chartString += "			are reversed for the bar chart. ";
		chartString += "			-->";
		chartString += "			<series type='bar' label='Actual score' fillColor='0x37B2EB'>";
			for (var x = 0; x < actualScoresData.length; x++) {
				chartString += "				<point y='" + parent.pages[actualScoresData.length - x - 1]._title + "' x='" + actualScoresData[actualScoresData.length - x - 1] + "' />";
			}
		chartString += "			</series>";
		
		chartString += "			<series type='bar' label='Max possible score' fillColor='0x002665'>";
			for (var x = 0; x < actualScoresData.length; x++) {
				chartString += "				<point y='" + parent.pages[actualScoresData.length - x - 1]._title + "' x='" + maximumScoresData[actualScoresData.length - x - 1] + "' />";
			}
		chartString += "			</series>";
		chartString += "		</set>";
		chartString += "	</data>";
		chartString += "</chart>";
		
		renderFlashChart("#section_scoresBarChart", chartString, 920, parent.sectionTrackingObjects.length * 70);
	}
}


// Renders a table showing all of the user's usage data
// Parameters: void;
// Returns:    void;
function drawUserDataTable() {
	if (exists(".userDataTable")) {
		var tableString = "";

		tableString += "<table class='zebra'>";
		tableString +=
			"<tr>" +
				"<th>Section Name</th>" + 
				"<th>Session Time</th>" +
				"<th>Overall Time</th>" +
				"<th>Status</th>"       +
				"<th>Actual Score</th>" +
				"<th>Max Score</th>"    +
			"</tr>";

		for (var x = 0; x < parent.sectionTrackingObjects.length; x++) {
			var prefix = x + ". ";
			if (x < 1) prefix = "";
			
			tableString += 
				"<tr>" +
					"<td class='sectionTitleCell'>" + prefix + parent.sectionTrackingObjects[x]._name + "</td>" + 
					"<td>" + parent.sectionTrackingObjects[x]._sessionTime + "</td>" + 
					"<td>" + parent.sectionTrackingObjects[x].getCurrentOverallTime() + "</td>" + 
					"<td><span class='sectionIcon " + convertStatusLong(parent.sectionTrackingObjects[x]._status).toLowerCase() + "'><span>" + convertStatusLong(parent.sectionTrackingObjects[x]._status) + "</span></span></td>" + 
					"<td>" + parent.sectionTrackingObjects[x]._actualScore + "</td>" + 
					"<td>" + parent.sectionTrackingObjects[x]._maxScore + "</td>" +
				"</tr>";
		}

		tableString +=
			"<tr class='moduleRow'>" +
				"<td class='sectionTitleCell'>Total for module</td>" + 
				"<td>" + parent.moduleTrackingObject._sessionTime + "</td>" + 
				"<td>" + parent.moduleTrackingObject.getCurrentOverallTime() + "</td>" + 
				"<td><span class='sectionIcon " + convertStatusLong(parent.moduleTrackingObject._status).toLowerCase() + "'><span>" + convertStatusLong(parent.moduleTrackingObject._status) + "</span></span></td>" + 
				"<td>" + parent.moduleTrackingObject._actualScore + "</td>" +
				"<td>" + parent.moduleTrackingObject._maxScore + "</td>" +
			"</tr>";
		tableString += "</table>";

		$(".userDataTable").html(tableString);
	}	
}




// =============================================================================================================================================
//		 # ERROR PAGE CONTROLS
// =============================================================================================================================================


// Sets up functionality for links only found on the error page
// Parameters: void;
// Returns:    void;
function setupErrorPageControls() {
	if (exists(".errorBox")) {
		$("#error_backToMainmenu").click(function(){
			parent.gotoHome();
			return false;
		});

		$("#error_retryPage").click(function(){
			parent.pageLoadTimeout += 5000;
			parent.resumePage();
			return false;
		});

		$("#error_viewErrorLog").click(function(){
			parent.showErrorLog();
			return false;
		});
	}
}




// =============================================================================================================================================
//		 # EXTENDERS
// =============================================================================================================================================


var hideExtenderContentWhileSliding = true;
var slidingInProgress = false;


// Initialise all extenders and extender controls on the current CONTENT page
// Parameters: void;
// Returns:    void;
function setupExtenders() {
	if (exists(".extenderContent")) {
		if (parent.extenderBoxesActive) {
			$(".extenderContent").hide(); // Close up all extenders
			$(".extenderButton").addClass("extenderClosed");

			$(".extenderContent").prepend("<div style='height: 1px;'></div>");	// Adding an empty div seems to fix unwanted 'slide bump'
			$(".extenderContent").append( "<div style='height: 1px;'></div>");	// Adding an empty div seems to fix unwanted 'slide bump'

			$(".extenderButton").click(function(){
				if ($(this).hasClass("extenderClosed")) openExtender(this); // Extender is currently closed so open it
				else closeExtender(this); // Extender is currently open so close it
				return false;
			});
			
			$(".extenderContent").addClass("extenderContentClosed");
		} else {
			$(".extenderContent").addClass("extenderContentOpen");
		}
		
		$(".extenderContent").after("<div class='clearFloat'></div>");		
		
		$(".extenderButton em").after("&nbsp;"); // Puts a space after extenderbutton content to avoid weirding line wrapping in AIR
	}
}


// Extends the specified HTML element to reveal content
// Parameters: obj:object;
// Returns:    void;
function openExtender(obj) {
	if (!slidingInProgress) {
		var extenderContent = findExtenderContent(obj);
		
		if ($(obj).hasClass("extenderClosed")) {
			if (parent.extenderSlidingActive) { // Extenders boxes will slide open and closed
				slidingInProgress = true;
				toggleFlashMovies(extenderContent);
				if (hideExtenderContentWhileSliding) $(extenderContent).children().css("visibility", "hidden");
				extenderContent.slideDown(parent.extenderSlidingSpeed, function(){
					if (hideExtenderContentWhileSliding) $(extenderContent).children().css("visibility", "visible");
					$(extenderContent).removeClass("extenderContentClosed");
					$(extenderContent).addClass("extenderContentOpen");
					toggleFlashMovies(extenderContent);
					slidingInProgress = false;
					readjust();
					renderQuestions();
				});
				setTimeout(function(){ // This is a backup function, it will make sure nothing is hidden which shouldn't be
					$(".extenderButton").each(function(){
						if ($(this).hasClass("extenderOpen")) {
							var backupExtenderContent = findExtenderContent(this);
							$(backupExtenderContent).children().css("visibility", "visible");
						}
					});
				}, 800);
			} else { // Extender box contents will just appear and disappear
					$(extenderContent).removeClass("extenderContentClosed");
					$(extenderContent).addClass("extenderContentOpen");
					extenderContent.show();
					readjust();
					renderQuestions();
			}

			$(obj).removeClass("extenderClosed");
			$(obj).addClass("extenderOpen");
		}
	}
}


// Collapses the specified HTML element to hide content
// Parameters: obj:object;
// Returns:    void;
function closeExtender(obj) {
	if (!slidingInProgress) {
		extenderContent = findExtenderContent(obj);

		if ($(obj).hasClass("extenderOpen")) {
			if (parent.extenderSlidingActive) { // Extenders boxes will slide open and closed
				slidingInProgress = true;
				toggleFlashMovies(extenderContent);
				if (hideExtenderContentWhileSliding) $(extenderContent).children().css("visibility", "hidden");
				extenderContent.slideUp(parent.extenderSlidingSpeed, function(){
					if (hideExtenderContentWhileSliding) $(extenderContent).children().css("visibility", "visible");
					$(extenderContent).removeClass("extenderContentOpen");
					$(extenderContent).addClass("extenderContentClosed");
					toggleFlashMovies(extenderContent);
					slidingInProgress = false;
					readjust();				
				});
			} else { // Extender box contents will just appear and disappear
				$(extenderContent).removeClass("extenderContentOpen");
				$(extenderContent).addClass("extenderContentClosed");
				extenderContent.hide();
				readjust();
				renderQuestions();
			}
			
			$(obj).removeClass("extenderOpen");
			$(obj).addClass("extenderClosed");
		}
	}
}


// Traverses the DOM to find the extenderContent attached to an extenderButton
// Parameters: obj:object;
// Returns:    object;
function findExtenderContent(obj) {
	return $(obj).parents(".extender").children(".extenderContent");
}


// Finds all Flash movies within the specified HTML object and toggles whether they are visible or not
// This is required for the extending animations as Firefox doesn't reveal/hide Flash movies correctly
// Parameters: obj:object;
// Returns:    void;
function toggleFlashMovies(obj) { // Some fancier functionality is required as Firefox doesn't slide flash content in and out properly
	// This has currently been disabled as it seemeed to be messing up question visibility
	//if ($(obj).find("embed").css("visibility") == "visible")			$(obj).find("embed").css("visibility", "hidden");
	//else	if ($(obj).find("embed").css("visibility") == "hidden") $(obj).find("embed").css("visibility", "visible");
}


// Tells CONTROL to readjust the size of the CONTENT frame to adapt the change in size after an extender has opened or closed
// Parameters: void;
// Returns:    void;
function readjust() {
	if (inParent) parent.resizeContentFrame();
}


// Finds all extenders on the current CONTENT page and opens them
// Parameters: void;
// Returns:    void;
function openAll() {
	openExtender($(".extenderButton"));
}


// Finds all extenders on the current CONTENT page and closes them
// Parameters: void;
// Returns:    void;
function closeAll() {
	closeExtender($(".extenderButton"));
}




// =============================================================================================================================================
//		 # PLACEHOLDERS
// =============================================================================================================================================


// Replace all instances of all variables on this page
// Parameters: void;
// Returns:    void;
function replaceAllPlaceholders() {
	if (inParent && exists(".placeHolder")) {

		// Replace placeholders set in XML file
		for (var x = 0; x < parent.replacementPlaceholdersOld.length; x++) {
			replacePlaceholder(parent.replacementPlaceholdersOld[x], parent.replacementPlaceholdersNew[x]);
		}

		var unattempted = 0;
		var incomplete	= 0;
		var completed   = 0;

		for (var x = 0; x < parent.sectionTrackingObjects.length; x++) {
			if (parent.sectionTrackingObjects[x]._status == 0) unattempted++;
			if (parent.sectionTrackingObjects[x]._status == 1) incomplete++;
			if (parent.sectionTrackingObjects[x]._status == 2) completed++;
		}

		// Replace placeholders with info about the module
		replacePlaceholder("module_title",                parent.moduleTitle);
		replacePlaceholder("module_version",              parent.moduleVersion);
		replacePlaceholder("module_number",               parent.moduleNumber);
		replacePlaceholder("m",                           parent.moduleNumber);
		replacePlaceholder("module_introduction",         parent.moduleIntro);
		replacePlaceholder("module_sessionTime",          parent.moduleTrackingObject._sessionTime);
		replacePlaceholder("module_overallTime",          parent.moduleTrackingObject.getCurrentOverallTime());
		replacePlaceholder("module_status",               convertStatusLong(parent.moduleTrackingObject._status));
		replacePlaceholder("module_actualScore",          parse(parent.moduleTrackingObject._actualScore));
		replacePlaceholder("module_maxScore",             parse(parent.moduleTrackingObject._maxScore));
				
		var percentScore = parse(Math.round((parse(parent.moduleTrackingObject._actualScore) / parse(parent.moduleTrackingObject._maxScore)) * 100));
		if (percentScore == 0) percentScore = "0";		
		replacePlaceholder("module_percentScore",         percentScore);			 
		
		replacePlaceholder("module_sectionsUnattempted",  unattempted);
		replacePlaceholder("module_sectionsIncomplete",	  incomplete);
		replacePlaceholder("module_sectionsCompleted",    completed);
		replacePlaceholder("module_noOfSections",         parse(parent.sectionTrackingObjects.length));
		replacePlaceholder("module_averageSectionTime",   convertSecondsToTime(convertTimeToSeconds(parent.moduleTrackingObject.getCurrentOverallTime()) / completed));

		replacePlaceholder("module_noOfQuestions",        parse(parent.sectionTrackingObjects.length) - 2);

		// Replace placeholders with info about the current section
		replacePlaceholder(	"section_title",              sectionTrackingObject._name);
		if (parent.currentPage > -1) {
			replacePlaceholder("section_number",          parent.currentPage);
		} else {
			replacePlaceholder("s",                       "");
		}
		
		if (parent.currentPage > -1) {
			replacePlaceholder("s",                       parent.currentPage);
		} else {
			replacePlaceholder("section_number",          "");
		}
		
		replacePlaceholder(	"section_sessionTime",        sectionTrackingObject._sessionTime);
		replacePlaceholder(	"section_overallTime",        sectionTrackingObject.getCurrentOverallTime());
		replacePlaceholder(	"section_status",             convertStatusLong(sectionTrackingObject._status));
		replacePlaceholder(	"section_actualScore",        parse(sectionTrackingObject._actualScore));
		replacePlaceholder(	"section_maxScore",           parse(sectionTrackingObject._maxScore));
		replacePlaceholder(	"section_percentScore",       parse(Math.round((parse(sectionTrackingObject._actualScore) / parse(sectionTrackingObject._maxScore)) * 100)));
	}
}


// Runs all instances of the specified variable within this page
// Parameters: oldVar:string, newVar:string;
// Returns:    void;
function replacePlaceholder(oldVal, newVal) {
	if (exists(".placeHolder." + oldVal)) $(".placeHolder." + oldVal).html(newVal);
}




// =============================================================================================================================================
//		 # RELATERS
// =============================================================================================================================================


// Sets up relater functionality
// Parameters: void;
// Returns:    void;
function setupRelaters() {
	if (exists(".relater")) {
		$(".relater").each(function(){
			$(this).mouseover(showRelater);
			$(this).mouseout(hideRelater);
			$(this).focus(showRelater);
			$(this).blur(hideRelater);
			
			$(this).click(function(){
				return false;
			});
		});
	}
}


// Finds the identifiying class on a relater (starts with rel_)
// Parameters: obj:Object;
// Returns:    string;
function findIdentifier(obj) {
	var identifier = "";
	
	var classes = $(obj).attr("class");
	var classesArray = new Array();
	classesArray = classes.split(" ");

	for (var x = 0; x < classesArray.length; x++) {
		if (classesArray[x].indexOf("rel_") == 0) identifier = classesArray[x];
	}
	
	return identifier;
}


// Highlights relaters which share the same href
// Parameters: void;
// Returns:    void;
function showRelater() {
	var identifier = findIdentifier(this);
	
	$(".relater").each(function(){
		if ($(this).hasClass(identifier)) $(this).addClass("relaterHighlight");
	});
}


// Unhighlights relaters which share the same href
// Parameters: void;
// Returns:    void;
function hideRelater() {
	var identifier = findIdentifier(this);
	
	$(".relater").each(function(){
		if ($(this).hasClass(identifier)) $(this).removeClass("relaterHighlight");
	});
}




// =============================================================================================================================================
//		 # QUESTIONS
// =============================================================================================================================================


var questionDebugAlerts = false; // Set to true to receive alerts showing Flash Javascript communication
var questionShowAnswers = false; // Set to true to be shown question answer in advance

var questionRenderCounter = 0; // Try rendering more than once...
var questionRenderMax     = 4; // but not too many times!


// Finds all question placeholders in the page and renders them
// Parameters: void;
// Returns:    void;
function renderQuestions() {
	if (exists(".question")) {
		if (!parent.extenderBoxesActive) {
			$("a.question").each(function() {
				$(this).html("Loading...");
			});
		}

		$("a.question").each(function() {
			// Don't look at questions which are in closed extender boxes
			if  (!inAnExtender(this, false) || inAnExtender(this, true)) {
				var id = $(this).attr("id");
				// Turn link into div
				$(this).after("<div id='" + $(this).attr("id") + "' class='" + $(this).attr("class") + "' href='" + $(this).attr("href") + "' style='" + $(this).attr("style") + "'></div>");
				$(this).remove();
				
				$("div#" + id).each(function() {				
					if (!$(this).hasClass("generatedQuestion")) {
						$(this).html("");

						// Render question
						if (parent.useFlashQuestions || $(this).hasClass("bespoke")) flashQuestionRender($(this));
						else javascriptQuestionRender($(this));
					}
				});
			}
		});
	}
	
	questionRenderCounter++;
	if (questionRenderCounter < questionRenderMax) setTimeout(renderQuestions, 1000);
}


// Detects whether the object is contained with an extender (and whether that extender is open or not)
// Parameters: obj:Object, isOpen:boolean;
// Returns:    boolean;
function inAnExtender(obj, isOpen) {
	var result = false;
	
	$(obj).parents().each(function(){
		if ($(this).hasClass("extenderContent")) {
			if (isOpen) {
				if ($(this).hasClass("extenderContentOpen")) result = true;
			} else result = true;
		}
	});
	
	return result;
}


// Main function for rendering questions with Flash
// Parameters: question:string;
// Returns:    void;
function flashQuestionRender(question) {
	var questionId	 = $(question).attr("id");
	var questionModel = "";

	$(question).before("<div class='questionText " + questionId + "'></div>");

	if ($(question).hasClass("journalEntry"))      questionModel = workingDirectory() + "questions/mainJournalEntry.swf";
	if ($(question).hasClass("multipleChoice"))    questionModel = workingDirectory() + "questions/mainMCQ.swf";
	if ($(question).hasClass("numberEntry"))       questionModel = workingDirectory() + "questions/mainNumber.swf";
	if ($(question).hasClass("multipleSelection")) questionModel = workingDirectory() + "questions/mainMSQ.swf";	
	if ($(question).hasClass("combo"))             questionModel = workingDirectory() + "questions/mainCombo.swf";
	if ($(question).hasClass("debitCredit"))       questionModel = workingDirectory() + "questions/mainDebitCredit.swf";
	if ($(question).hasClass("date"))              questionModel = workingDirectory() + "questions/mainDate.swf";
	if ($(question).hasClass("textEntry"))         questionModel = workingDirectory() + "questions/mainText.swf";
	if ($(question).hasClass("flexi"))         questionModel = workingDirectory() + "questions/mainFlexi.swf";
	if ($(question).hasClass("bespoke"))           questionModel = $(question).attr("href");

	
	


	var disabledQuestion = false;

	var questionObject = sectionTrackingObject.findInteraction(questionId);
	if (questionObject._attempts > 0) disabledQuestion = true;

	// Set the appropriate wmode
	var wmode = "transparent"; // Proper z-index but doesn't tab properly
	if (parent.tabFriendlyMode) wmode = "window"; // Floats on tab but fully accessible

	var bgcolor = rgbConvert($(question).parent().css("background-color")); // Set the correct background colour
	var textColour =  rgbConvert($(".questionText").css("color"));// Get the font colour
	var textSize =  $(".questionText").css("font-size");// Get the font colour
	//var textSize =  $(question).parent().css("font-size");// Get the font colour

	

	$(question).flash({
		src:                questionModel,
		flashvars: {
			id:               questionId,
			xmlUrl:           $(question).attr("href"),
			examMode:         parent.assessment,
			disabledQuestion: disabledQuestion,
			highContrastMode:	parent.highContrastMode,
			currentFontSize:	parent.currentFontSize,
			textSize:			textSize,
			textColour:			textColour
		},
		allowscriptaccess:  "always",
		wmode:              wmode,
		bgcolor:            bgcolor
	});

	//$(question).css("visibility", "hidden");

	$(question).after("<div class='feedbackText " + questionId + "'></div>");
	$(question).addClass("generatedQuestion");
	$(question).click(function(){  return false;  });
	resizeMovie(questionId, 780, 500);
	
	//DS suggested this code as a possible fix for teh questions shrinking issue
	/*if (!$("." + questionId).hasClass("questionInitiated")) { // If this id hasn't been given an initial before...
   resizeMovie(questionId, 300, 200);  // ... then go ahead and resize it
   $("." + questionId).addClass("questionInitiated"); // ... but also flag it so next time the resize code won't get called
}*/
	
	//catch any QUESTIONS that aren't set to anything valid
	var tempclass = $(question).attr("class");
	var tempClassSplit = tempclass.split(" ");
	if (questionModel == ""){
		setQuestionText(questionId, "<b>ERROR: </b> The class attribute in the question link must contain the word questions followed by a valid question type e.g. &lt;a id=\"q2\" class=\"question numberEntry\" [...]&lt;/a&gt; <br />class=\""  + tempClassSplit[0]+ " " +tempClassSplit[1]+ "\" is not valid");
	}

	if (questionShowAnswers) {
		ajaxXml($(question).attr("href"), function(xml){
			var xmlManifest = $.xmlToJSON(xml);
			setFeedbackText(questionId, "<b>Answer: </b>" + xmlManifest.questionTexts[0].explanation[0].Text);
		});
	}
	
	
}


// Alternative method for rendering questions than using Flash
// Parameters: question:string;
// Returns:    void;
function javascriptQuestionRender(question) {
	$(question).html("");
	
	ajaxXml($(question).attr("href"), function(xml){
		var xmlManifest = $.xmlToJSON(xml);

		var qString = "";

		if (xmlManifest.questionTexts) {		
			qString += "<h2>Question:</h2>";
			qString += "<p>" + xmlManifest.questionTexts[0].stem[0].Text + "</p>";
			
			if ($(question).hasClass("multipleSelection")||$(question).hasClass("multipleChoice")) {
				try
				{
				for (var i = 0; i <xmlManifest.matches[0].match.length; i++) {
					qString += "<p>" + xmlManifest.matches[0].match[i].value[0].Text + "</p>";					
				}
				}catch(err){
					qString += "<p> Error: unable to read in options list </p>";
				}
			}
			if ($(question).hasClass("combo")) {
				try
				{	
					var numInputsArray = [];//create an array to contain all numberinputs that update totals
					qString += "<table>";				
					for (var i = 0; i <xmlManifest.matches[0].match[0].rows[0].row.length; i++) {
						qString += "<tr>";
							for (var j = 0; j <xmlManifest.matches[0].match[0].rows[0].row[i].controls[0].control.length; j++) {
								qString += "<td>";
								//remeber you are using JSON so this is an OBJECT!!!
								//working on getting the type of control out and hten inserting a meaningful value for reading with a screen reader.
								//we need to do something with totsl and combo boxes
								var control =xmlManifest.matches[0].match[0].rows[0].row[i].controls[0].control[j];
								if (control.type == "text"){
									qString +=xmlManifest.matches[0].match[0].rows[0].row[i].controls[0].control[j].Text;
								}
								if (control.type == "numberInput"){
									qString += "<p>"+control.value+"</p>";
									//find out if it updates dusplay total, if it does, get its id and its value.
									if  (control.updatesDisplayTotal=="true"){
										var idValue = [];//create an array to contain the id and the value
										idValue[0]= control.id;
										idValue[1] = control.value;
										numInputsArray.push(idValue);//add this to the other array
									}
								}//end if num input
								if (control.type == "textInput"){
									qString += "Fill in the blank";
								}//end if text inp
								
								if (control.type == "total"){
									var value= 0 ;
									if (control.formula) {
										var formula = control.formula;
										for (var nIndex=0; nIndex<numInputsArray.length; nIndex++){
											formula=formula.replace("{"+numInputsArray[nIndex][0]+"}",numInputsArray[nIndex][1]);											
										}//end for nIndex
										
										//code to try to add all this up (you don't even wat to know whats going on- its the same as the flex code in combo model refre to that
					//var regEx=
					//javascriopt does not allow a zero width postive lookbehind regualr expression - which is what we use in flex
					//so we're going to ahev tro try  somre pretty horrendous code 9involgin revresing strings and regular expressions to mimic this
					var regEx=/(?=\d)[\-\+\/\*]/ig;
					//var operator=formula.reverse().match(regEx).reverse(); //this shoudl return an array
					alert("operator"+operator.toString());
					/*splitArray=formula.split(regEx);//and another array
					var result=0;					
					var tempResult= parseFloat(splitArray[0]);
					if (operator.length>0){
						var remainderString=formula.substring(formula.indexOf(operator[0])+1,formula.length);
					}else{
						result=tempResult;
					}
					//evaluate the expression depending on the operator
					for (sIndex=0;sIndex<splitArray.length-1;sIndex++){					
						if (operator!=null){

						switch (operator[0]){
						case "*":
						
							result=parseFloat(tempResult)*parseFloat(splitArray[sIndex+1]);
							break;
						case "+":
						result=parseFloat(tempResult)+parseFloat(splitArray[sIndex+1]);				
							break;
						case "-":
						result=parseFloat(tempResult)-parseFloat(splitArray[sIndex+1]);					
							break;
						case String("/"):
						result=parseFloat(tempResult)/parseFloat(splitArray[sIndex+1]);					
						break;	
						default:
						//faultMessage="Unable to calculate value for variable "+ group.name +". The expression to be calculated is not valid.";
						//varError=true;
						break;	
						}//end switch
						tempResult=result;
						operator=remainderString.match(regEx);
						var tempString=remainderString;

						if (operator){
						remainderString=tempString.substring(tempString.indexOf(operator[0])+1,tempString.length);
						}//end if
					}	//end for
					*/

									

						if (isNaN(result)){
							formula="No value calculated";
						}else{
							formula=result;	
						}//end if isNan
					}//end if formula
				qString += "total " +formula ;
				}//end if total
								if (control.type =="combo"){
									qString += "Select an item from this list: ";
									sourceListId= control.source;
									//qString += sourceListId;
									var listFound=false;
									
									for (var k = 0; k <xmlManifest.settings[0].dropDownLists[0].dropDownList.length; k++){
										var listId= xmlManifest.settings[0].dropDownLists[0].dropDownList[k].id;
										if (sourceListId==listId){
											var listFound=true;
											//this may not work as item seems to be a reserved word.
	
											for (var l = 0; l <xmlManifest.settings[0].dropDownLists[0].dropDownList[k].item.length; l++){
												qString+=xmlManifest.settings[0].dropDownLists[0].dropDownList[k].item[l].Text+ ", ";
											}//end for
											if(!listFound){
											qString += "Error: list not found";
											}//emd if
										}//end if (sourceListId==listId)	
										
									}	//end if combo							
								}//end for j (control)						
							qString +="</td>";
						}
					qString +="</tr>";					
				}
				qString += "</table>";
			}
				catch(err){
							//error
							qString += "<p>Error: unable to read in part of question</p>";
				}//end try?
			}//end combo
			if ($(question).hasClass("journalEntry")) {
				try{
					//journal entry reading in code
					qString += "<p> Accounts list:</p> <ul>";
					var listId= xmlManifest.settings[0].accountList[0];
					for (var listIndex=0; listIndex<listId.item.length; listIndex++){						
						qString += "<li> "+listId.item[listIndex].Text +" </li>";
					}
					qString += "</ul>";
				}
				catch(err){
					//error code
					qString +="<p> Error: unable to read in accounts list </p>";
				}
			}


			//if (!parent.assessment) {
				qString += "<h2>Answer:</h2>";
				qString += "<p>" + xmlManifest.questionTexts[0].explanation[0].Text + "</p>";
			//}		
		}

		$(question).after(qString);
		$(question).remove();
		
		readjust();
	});
}
String.prototype.reverse = function () {
	alert("reversing");
	return this.split('').reverse().join('');
};


// Sets the content of the questionText
// Parameters: id:string, questionText:string;
// Returns:    void;
function setQuestionText(id, questionText) {
	if (questionDebugAlerts) alert("setQuestionText(" + id + ", " + questionText + ")");
	
	$(".questionText." + id).html(questionText);

	var questionObject = sectionTrackingObject.findInteraction(id);
	questionObject.setDescription(questionText);
	
	commonSetup();
	return "successful";
}


// Sets the content of the questionText by loading content from another file
// Parameters: id:string, url:string;
// Returns:    void;
function setQuestionTextFromUrl(id, url) {
	if (questionDebugAlerts) alert("setQuestionTextFromUrl(" + id + ", " + url + ")");

	ajax(url, function(text){
		$(".questionText." + id).html(text);
		
		var questionObject = sectionTrackingObject.findInteraction(id);
		questionObject.setDescription(text);
		
		commonSetup();
	});

	return "successful";
}


// Sets the content of the feedbackText and shows it
// Parameters: id:string, feedbackText:string;
// Returns:    void;
function setFeedbackText(id, feedbackText) {
	if (questionDebugAlerts) alert("setFeedbackText(" + id + ", " + feedbackText + ")");
	
	
	$(".feedbackText." + id).html(feedbackText);
	showFeedbackText(id);
	return "successful";
}


// Sets the content of the questionText by loading content from another file
// Parameters: id:string, url:string;
// Returns:    void;
function setFeedbackTextFromUrl(id, url) {
	if (questionDebugAlerts) alert("setFeedbackTextFromUrl(" + id + ", " + url + ")");
	
	ajax(url, function(text){
		$(".feedbackText." + id).html(text);		
		showFeedbackText(id);
	});	

	return "successful";
}


// Hides the feedback text
// Parameters: id:string;
// Returns:    void;
function hideFeedbackText(id) {
	if (questionDebugAlerts) alert("hideFeedbackText(" + id + ")");

	
	$(".feedbackText." + id).hide();
	readjust();
	return "successful";
}


// Shows the feedback text
// Parameters: id:string;
// Returns:    void;
function showFeedbackText(id) {
	if (questionDebugAlerts) alert("showFeedbackText(" + id + ")");
	
	$(".feedbackText." + id).show();
	commonSetup();
	return "successful";
}


// Resizes the embeded movie size to fit the actual movie size
// Parameters: id:string, width:integer, height:integer;
// Returns:    void;
function resizeMovie(id, width, height) {
	if (questionDebugAlerts) alert("resizeMovie(" + id + ", " + width + ", " + height + ")");
	
	$("#" + id + " embed").css("width", width + "px");
	$("#" + id + " embed").css("height", height + "px");

	$("#" + id + " embed").attr("width",	width);
	$("#" + id + " embed").attr("height", height);

	readjust();

	return "successful";
}


// Called by Flash question movies once they have fully loaded
// Parameters: id:string, maxScore:integer;
// Returns:    void;
function movieReady(id, xmlId, maxScore, correctAnswer) {
	if (questionDebugAlerts) alert("movieReady(" + id + ", " + xmlId + ", " + maxScore + ", " + correctAnswer +")");
	
	hideFeedbackText(id);
	
	$("#" + id).css("visibility", "visible");

	var questionObject = sectionTrackingObject.findInteraction(id);
	
	if ($("#" + id).hasClass("journalEntry"))      questionObject._type = FILL_IN; //NUMERIC; (Anything other than FILL_IN wasn't recorded user inputs the way we wanted)
	if ($("#" + id).hasClass("multipleChoice"))    questionObject._type = FILL_IN; //CHOICE;
	if ($("#" + id).hasClass("numberEntry"))       questionObject._type = FILL_IN; //NUMERIC;
	if ($("#" + id).hasClass("multipleSelection")) questionObject._type = FILL_IN; //CHOICE;
	if ($("#" + id).hasClass("combo"))             questionObject._type = FILL_IN;
	if ($("#" + id).hasClass("debitCredit"))       questionObject._type = FILL_IN; //NUMERIC;
	if ($("#" + id).hasClass("bespoke"))           questionObject._type = FILL_IN; //CHOICE;

	questionObject._xml_id           = xmlId;
	questionObject._weighting        = maxScore;
	questionObject._correct_response = correctAnswer;
	questionObject.start();
	
	if (questionObject._attempts > 0 && parent.assessment) {
		setFeedbackText(id, "<b>Your previously entered answer: </b>" + questionObject._learner_response);
	} else hideFeedbackText(id);	
}


// Collects all input data once a user has submitted a question
// Parameters: id:string, xmlId:string, userAnswer:string, questionState:string, score:integer, maxScore:integer;
// Returns:    void;
function sendDataOut(id, xmlId, userAnswer, questionState, score, maxScore) {
	if (questionDebugAlerts) alert("sendDataOut(" + id + ", " + xmlId + ", " + userAnswer + ", " + questionState + ", " + score + ", " + maxScore + ")"); 
	
	var questionObject = sectionTrackingObject.findInteraction(id);

	questionObject._xml_id           = xmlId;
	questionObject._learner_response = userAnswer;	
	questionObject._weighting        = maxScore;

	if (score > 0) questionObject.setCorrect(score);
	else           questionObject.setIncorrect();
}




// =============================================================================================================================================
//		 # TABS
// =============================================================================================================================================


// Initialise functions
// Parameters: void;
// Returns:    void;
function setupTabs() {
	if (exists(".tabContainer")) {
		var activateTabs = false;
		
		try {
			if (inParent) {
				if (parent.tabsActive) activateTabs = true;
			}
		} catch(err) {} // If there is no parent available then ignore the error thrown
		
		try {
			if (opener) {
				if (opener.tabsActive) activateTabs = true;
			}
		} catch(err) {} // If there is no opener available then ignore the error thrown
		
		if (activateTabs) {
			 var selectedTab = 0;
			 
			 if (exists(".initial")) {
				 $(".tabContainer ul").each(function(){ // Find if there is an initial tab set
					var links = $(this).find("a");
					for (var x = 0; x < links.length; x++) {
						if ($(links[x]).hasClass("initial")) selectedTab = x;
					}
				 });
			 }
			 
			 $(".tabContainer > ul").tabs({ selected: selectedTab }); // Activate tabs
			 
			$(".tabContainer ul li a").click(function() {
				$(this).focus();
			});

			// This step needs a tiny delay to make sure any stylesheets have been updated first
			setTimeout(function(){
				// Set tab container so all content boxes are the same height
				$(".tabContainer").each(function(){						 
					maxHeight = getMaxTabHeight($(this).children(".ui-tabs-panel"));
					$(this).children(".ui-tabs-panel").height(maxHeight);
				});

				readjust();
			}, 300);
		}
	}
}


// Runs through an array of divs and returns the height of the tallest
// Parameters: $tabpanels:div[];
// Returns:    integer;
function getMaxTabHeight($tabpanels) {
	var maxHeight =
			$.map($tabpanels, function(el) {
					return $(el).height();
			})
			.sort(function(a, b) {
					return b - a;
			})[0];

	return maxHeight;
}




// =============================================================================================================================================
//		 # TRACKING
// =============================================================================================================================================


var sectionTrackingObject;

function setupSectionTrackingObject() {
	if (inParent && parent.currentPage > -1) {
		sectionTrackingObject = parent.sectionTrackingObjects[parent.currentPage];
		sectionTrackingObject.startTiming();
		sectionTrackingObject.setComplete();
		sectionTrackingObject._maxScore		= $(".question").length;
		sectionTrackingObject._actualScore = 0;
	} else {
		sectionTrackingObject = new TrackingObject(getWindowTitle());
	}
}


$(window).unload(function() {
	sectionTrackingObject.setComplete();
	sectionTrackingObject.stopTiming();
});




// =============================================================================================================================================
//		 # SPECIAL CODE
// =============================================================================================================================================


var specialArray  = new Array();
var ticking       = false;
var specialActive = false;


function activateSpecial() {
	specialActive = true;
}


function specialDown() {
	if (specialActive) {
		if (specialArray.length > 0) {
			specialArray[specialArray.length-1].destroy();
			specialArray.pop();
		}
	}
}


function specialUp() {
	if (specialActive) {
		specialArray.push(new SpecialObject(specialArray.length));
		if (!ticking) {
			ticking = true;
			tickTock();
		}
	}
}


function SpecialObject(id) {
	this.id = "special" + id;
	this.width = 5 + (5 * rand(8));
	this.colour = rgbConvert("rgb(" + rand(255) + ", " + rand(255) + ", " + rand(255) + ", )");
	this.posx = rand($(window).width()) - this.width;
	this.posy = rand($(window).height()) - this.width;
	do {
		this.dirx = rand(3) - 1;
		this.diry = rand(3) - 1;
	} while (this.dirx == 0 || this.dirx == 0);
	this.speedx = rand(5) + 1;
	this.speedy = rand(5) + 1;

	$("body").append("<div class='specialClass' id='" + this.id + "' style='display: block; position: fixed; top: " + this.posy + "px; left: " + this.posx + "px; width: " + this.width + "px; height: " + this.width + "px; background-color: " + this.colour + "'></div>");	
}


SpecialObject.prototype.destroy = function() {
	$("#" + this.id).remove();
};


SpecialObject.prototype.tick = function() {
	this.posx += this.dirx * this.speedx;
	this.posy += this.diry * this.speedy;
	
	if (this.posx < 0) {
		this.posx = 0;
		this.dirx = this.dirx * -1;
	}
	
	if (this.posy < 0) {
		this.posy = 0;
		this.diry = this.diry * -1;
	}
	
	if (this.posx > $(window).width() - this.width) {
		this.posx = $(window).width() - this.width;
		this.dirx = this.dirx * -1;
	}
	
	if (this.posy > $(window).height() - this.width) {
		this.posy = $(window).height() - this.width;
		this.diry = this.diry * -1;
	}
	
	$("#" + this.id).css("top", this.posy + "px");
	$("#" + this.id).css("left", this.posx + "px");	
};


function tickTock() {
	for (var x = 0; x < specialArray.length; x++) specialArray[x].tick();
	setTimeout(function(){ tickTock(); }, 100);
}

SpecialObject.prototype.id;
SpecialObject.prototype.width;
SpecialObject.prototype.colour;
SpecialObject.prototype.posx;
SpecialObject.prototype.posy;
SpecialObject.prototype.dirx;
SpecialObject.prototype.diry;
SpecialObject.prototype.speedx;
SpecialObject.prototype.speedy;